/***
BEGIN LICENSE
Copyright (C) 2012 Erasmo Marín <erasmo.marin@gmail.com>
This program is free software: you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License version 3, as published
by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranties of
MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program.  If not, see <http://www.gnu.org/licenses/>.
END LICENSE
***/

using Gee;

namespace Foto.AlbumManager {

    public class Album : GLib.Object{

        public string album_name {set; get;}
        public string description {set; get;}
        public int rating {set; get; default = 3;}
        public DateTime creation_date {private set; get;}
        public ArrayList<Picture> picture_list; /*It saves the static path to file*/
        public Picture album_cover {set; get;}

        public Album(string album_name, string? description, DateTime? creation_date, Picture? album_cover, int rating){
            this.album_name = album_name;
            this.description = description;
            this.rating = rating;
            if(creation_date != null) 
                this.creation_date = creation_date;
            else 
                this.creation_date = new DateTime.now_local();
            if(album_cover != null)
                this.album_cover = album_cover;
            else
                this.album_cover = new Picture(null, null);
            picture_list = new ArrayList<Picture>();
        }

        public void add_picture(string picture_path, string? description){
            picture_list.add(new Picture(picture_path, description));
        }

        public void remove_picture(){
            return;
        }

        //return album creation time in sqlite valid format YYYY-MM-DDTHH:MM:SS.SSS
        public string? get_creation_time(){
            return creation_date.to_string();
        }
        
        public int get_n_pictures(){
        	if(picture_list == null) return 0;
        	else return picture_list.size;
        }

    }
 }
