//
//  Copyright (C) 2012 Erasmo Marín
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

using Gtk;
using Foto.Widgets;

namespace Foto.Dialogs{

	public class ProgressDialog : Gtk.Window {
        
        ProgressBar progress_bar;

		public ProgressDialog(string title, string description){

            set_title(_("title"));
            set_resizable(false);
            var content_grid = new Gtk.Grid ();
            content_grid.row_spacing = 6;
            content_grid.column_spacing = 12;
            content_grid.margin_top = 12;
            content_grid.margin_bottom = 12;         
            progress_bar = new ProgressBar();
            var label = new Label(description);

            set_progress(0.0);
            content_grid.attach(label,0,0,1,1);
            content_grid.attach(progress_bar,0,1,1,1);

            this.add(content_grid);
            this.show_all();      		
		}

        public void set_progress(double progress) {
            progress_bar.set_fraction(progress);
        }
		
		
    }
}

