//
//  Copyright (C) 2012 Erasmo Marín
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//


using Foto.Views;
using Foto.Widgets;
using MetadataReader;

namespace Foto.Dialogs{

public class PropertiesWindow : Granite.Widgets.LightWindow {

		public PropertiesWindow(string file_path){

             PictureMetadata info = new PictureMetadata(file_path);

             /*print("\nCreation time: " + info.creation_time);
             print("\nLast acces: " + info.last_access);
             print("\nLast changed: " + info.last_changed);
             print("\nLast modified: " + info.last_modified);
             print("\nFile size: %d", (int)info.size);*/

             print("\nMime Type: " + info.mime_type);
             print("\nCamera Model: " + info.camera_model);
             print("\nComment: " + info.comment);
             print("\nDate Time: " + info.date_time);
             print("\nFocal Length: %f", (float)info.focal_length);
             print("\nRating: %d", (int)info.rating);
             print("\nPixel Width: %d", info.pixel_width);
             print("\nPixel Height: %d", info.pixel_height);

       		 var light_window_notebook = new Granite.Widgets.StaticNotebook ();
           	 var entry = new Gtk.Entry ();
           	 var open_drop = new Gtk.ComboBoxText ();
           	 var open_lbl = new LLabel ("Always Open Jpeg Image Files with Foto");
            
           	 var grid = new Gtk.Grid ();
           	 grid.attach (new Gtk.Image.from_icon_name ("image-x-generic", Gtk.IconSize.DIALOG), 0, 0, 1, 2);
           	 grid.attach (entry, 1, 0, 1, 1);
           	 grid.attach (new LLabel ("2.1 mb, jpeg image file"), 1, 1, 1, 1);
            
           	 grid.attach (light_window_notebook, 0, 2, 2, 1);
            
           	 var general = new Gtk.Grid ();
           	 general.attach (new LLabel.markup (_("<b>Info:</b>")), 0, 0, 2, 1);
            
           	 general.attach (new LLabel.right (_("Created:")), 0, 1, 1, 1);
           	 general.attach (new LLabel.right (_("Modified:")), 0, 2, 1, 1);
           	 general.attach (new LLabel.right (_("Opened:")), 0, 3, 1, 1);
           	 general.attach (new LLabel.right (_("Mimetype:")), 0, 4, 1, 1);
           	 general.attach (new LLabel.right (_("Location:")), 0, 5, 1, 1);
            
           	 general.attach (new LLabel ("Today at 9:50 PM"), 1, 1, 1, 1);
           	 general.attach (new LLabel ("Today at 9:50 PM"), 1, 2, 1, 1);
           	 general.attach (new LLabel ("Today at 10:00 PM"), 1, 3, 1, 1);
           	 general.attach (new LLabel ("image/jpg"), 1, 4, 1, 1);
           	 general.attach (new LLabel ("/home/user/images"), 1, 5, 1, 1);
            
           	 general.attach (new LLabel.markup (_("<b>Open with:</b>")), 0, 6, 2, 1);
           	 general.attach (open_drop, 0, 7, 2, 1);
           	 general.attach (open_lbl, 0, 8, 2, 1);
            
             var more = new Gtk.Grid ();
           	 more.attach (new LLabel.markup (_("<b>Metadata:</b>")), 0, 0, 2, 1);
             
           	 more.attach (new LLabel.right (_("Camera model:")), 0, 1, 1, 1);
           	 more.attach (new LLabel.right (_("Comment:")), 0, 2, 1, 1);
           	 more.attach (new LLabel.right (_("Date time:")), 0, 3, 1, 1);
           	 more.attach (new LLabel.right (_("Focal length:")), 0, 4, 1, 1);
           	 more.attach (new LLabel.right (_("Resolution:")), 0, 5, 1, 1);
           	 more.attach (new LLabel.right (_("Orientation:")), 0, 6, 1, 1);
           	 more.attach (new LLabel.right (_("Rating:")), 0, 7, 1, 1);

           	 more.attach (new LLabel (info.camera_model), 1, 1, 1, 1);
           	 more.attach (new LLabel (info.comment), 1, 2, 1, 1);
           	 more.attach (new LLabel (info.date_time), 1, 3, 1, 1);

             //focal lengh
             string focal_lengh;
             if(info.focal_length == -1)
                focal_lengh = _("Unknown");
             else
                focal_lengh = info.focal_length.to_string();
           	 more.attach (new LLabel (focal_lengh), 1, 4, 1, 1);

             //Resolution
             string res = info.pixel_width.to_string() + "x" + info.pixel_height.to_string();
           	 more.attach (new LLabel (res), 1, 5, 1, 1);
            
             //orientation
           	 more.attach (new LLabel (info.orientation_to_string(info.orientation)), 1, 6, 1, 1);

             var rating = new Rating(info.rating);
           	 more.attach (rating, 1, 7, 1, 1);
             rating.rating_changed.connect((rating) => { info.rating = rating; } );
             

           	 light_window_notebook.append_page (general, new Gtk.Label (_("General")));
           	 light_window_notebook.append_page (more, new Gtk.Label (_("More")) );
           	 
           	 open_lbl.margin_left = 24;
           	 open_drop.margin_left = 12;
           	 open_drop.append ("foto", "Foto");
           	 open_drop.active = 0;
           	 grid.margin = 12;
           	 grid.margin_top = 24;
           	 grid.margin_bottom = 24;
           	 entry.text = _("Image name");
           	 general.column_spacing = 6;
           	 general.row_spacing = 6;
           	 more.column_spacing = 6;
           	 more.row_spacing = 6;
           	 
           	 this.add (grid);
		     this.move_center();
           	 this.show_all ();
		}

	//Move the PropertiesWindow to the center of the fotoviewer window 
	private void move_center(){
		 int x,y, lwidth, lheight, wwidth, wheight;
		 main_window.get_position(out x, out y);
		 main_window.get_size(out wheight, out wwidth);
		 this.get_size(out lwidth, out lheight);
		 x+= wwidth/2 - lwidth/2;
         y+=50;
		 this.move(x,y);
    }
    }
}

