/***
BEGIN LICENSE
Copyright (C) 2011 Erasmo Marín <erasmo.marin@gmail.com>
This program is free software: you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License version 3, as published
by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranties of
MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program.  If not, see <http://www.gnu.org/licenses/>.
END LICENSE
***/

using Foto.Dialogs;
using Gtk;

namespace Foto.Widgets{

    public class FotoMenu : Gtk.Menu {
		
	public Gtk.MenuItem preferences;
	private Gtk.CheckMenuItem m_fullscreen;
    private MainWindow window;
    public bool options;
        
        public FotoMenu () {
			//bool
			this.options = false;
			this.preferences = new Gtk.MenuItem.with_label(_("Options"));
			this.m_fullscreen = new Gtk.CheckMenuItem.with_label (_("Fullscreen"));

			append(preferences);
			append(m_fullscreen);
        }		
		

	public void set_new_window(MainWindow window){
		this.window = window;
		preferences.activate.connect ( () => toggle_options () );
		this.m_fullscreen.toggled.connect (toggle_fullscreen);
	}

	private void toggle_fullscreen () {
		
		if (m_fullscreen.get_active()){
			this.window.fullscreen ();
			window.is_fullscreen = true;
		} else{
			this.window.unfullscreen ();
			window.is_fullscreen = false;
		}
	}
		
	private void toggle_options(){	
		var dialog = new SettingsDialog();
		
		dialog.response.connect((response)=>{
        	//IF CLOSE
        	if(response == ResponseType.CLOSE)
        		dialog.destroy();
        });
        dialog.run();
	}
		
	}
}
